Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1055398 - Review Request: 0install - A decentralized cross-distribution software installation system
Summary: Review Request: 0install - A decentralized cross-distribution software instal...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1055395 1055396 1066133
Blocks: 1011411
TreeView+ depends on / blocked
 
Reported: 2014-01-20 07:36 UTC by Michel Alexandre Salim
Modified: 2014-03-05 05:12 UTC (History)
2 users (show)

Fixed In Version: 0install-2.6.1-2.fc19
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-02-26 13:56:11 UTC
loganjerry: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Michel Alexandre Salim 2014-01-20 07:36:24 UTC
Spec URL: http://salimma.fedorapeople.org/specs/ocaml/0install.spec
SRPM URL: http://salimma.fedorapeople.org/specs/ocaml/0install-2.5.1-1.fc20.src.rpm
Description:
NOTE: this is a renaming of the existing package zeroinstall-injector.
      Due to upstream rewrite (from pure Python to OCaml and Python)
      it seems like a good time for a re-review and rename

Zero Install is a decentralised cross-distribution software
installation system available under the LGPL. It allows software
developers to publish programs directly from their own web-sites,
while supporting features familiar from centralised distribution
repositories such as shared libraries, automatic updates and digital
signatures. It is intended to complement, rather than replace, the
operating system's package management. 0install packages never
interfere with those provided by the distribution.

0install does not define a new packaging format; unmodified tarballs
or zip archives can be used. Instead, it defines an XML metadata
format to describe these packages and the dependencies between them. A
single metadata file can be used on multiple platforms (e.g. Ubuntu,
Debian, Fedora, openSUSE, Mac OS X and Windows), assuming binary or
source archives are available that work on those systems.

0install also has some interesting features not often found in
traditional package managers. For example, while it will share
libraries whenever possible, it can always install multiple versions
of a package in parallel when there are conflicting
requirements. Installation is always side-effect-free (each package is
unpacked to its own directory and will not touch shared directories
such as /usr/bin), making it ideal for use with sandboxing
technologies and virtualisation.

The XML file describing the program's requirements can also be
included in a source-code repository, allowing full dependency
handling for unreleased developer versions. For example, a user can
clone a Git repository and build and test the program, automatically
downloading newer versions of libraries where necessary, without
interfering with the versions of those libraries installed by their
distribution, which continue to be used for other software.

Fedora Account System Username: salimma

Comment 1 Michel Alexandre Salim 2014-01-20 15:06:00 UTC
Update to 0install 2.6:

Spec URL: http://salimma.fedorapeople.org/specs/ocaml/0install.spec
SRPM URL: http://salimma.fedorapeople.org/specs/ocaml/0install-2.6-1.fc20.src.rpm

Comment 2 Jerry James 2014-02-07 18:47:49 UTC
I will take this review.

Comment 3 Jerry James 2014-02-12 16:37:26 UTC
The build fails:

Error: Cannot find file /usr/lib64/ocaml/biniou/biniou.cmxa
Command exited with code 2.
make[2]: *** [ocaml] Error 10

I don't see a BR on ocaml-biniou-devel in the spec file, which would be the cause of this error.

Also, version 2.6.1 has been released.

Comment 4 Jerry James 2014-02-12 17:07:18 UTC
After adding a BR on ocaml-biniou-devel to the spec file, the build still fails:

Error: Cannot find file /usr/lib64/ocaml/easy-format/easy_format.cmx
Command exited with code 2.
make[2]: *** [ocaml] Error 10

So a BR on ocaml-easy-format-devel is also necessary.

Comment 5 Jerry James 2014-02-12 18:04:41 UTC
Review done on Fedora 20, since the Rawhide buildroot is currently broken due to an incomplete icu update.

Issues, in no particular order:
 1) Missing BRs on ocaml-biniou-devel and ocaml-easy-format-devel.
 2) BR on ocaml-findlib-devel should just be on ocaml-findlib.
 3) Add "ExclusiveArch: %{ocaml_arches}".  Will this be a problem, since
    zeroinstall-injector was available for all arches?  That is, non-ocaml
    arches will not have an upgrade path available to them.
 4) Remove the "rm -rf $RPM_BUILD_ROOT" at the top of %install.
 5) Don't strip the cmxs files.
 6) The latest changelog entry says "Update to 2.6.1", but it appears that the
    package is actually for 2.6, not 2.6.1.
 7) Speaking of the changelog, I question the usefulness of keeping the
    changelogs from the previous package.  Think about whether it would be
    better to start over on the changelog.
 8) The spec file gives the license as "LGPLv2", but README.md contains the
    "any later version" clause.  Shouldn't the license be "LGPLv2+"?
 9) The spec has a BR on ocaml-dbus-devel, but I see this in the build log:

    obus not found; compiling without D-BUS support

    I think it wants this: http://forge.ocamlcore.org/projects/obus/.  Does
    that mean that the BR on ocaml-dbus-devel is unneeded?  Indeed, I see no
    references in the code to dBus, which is what ocaml-dbus-devel provides.
10) "Provides" for the old package name are great, but I don't think that
    "Obsoletes" is correct.  Doing it this way means that each time you bump
    NEVR on the new package, it will obsolete the previous version of itself.
    https://fedoraproject.org/wiki/Packaging:Guidelines#Renaming.2FReplacing_Existing_Packages
    indicates that in "Obsoletes: oldpackagename < $obsEVR", obsEVR is chosen
    so that "there is a clean upgrade path but without gratuitously polluting
    the version space upwards.  You usually do not use macros for this as
    you're simply trying to advance beyond the last known release under the old
    name."  Since 2.3.3 was the last version of zeroinstall-injector built for
    Fedora, you could do either of these:

    Obsoletes: zeroinstall-injector < 2.4-1%{?dist}
    Obsoletes: zeroinstall-injector < 2.5-1%{?dist}

11) In %description, use the American spelling of centralized, decentralized,
    and virtualization.
12) Regarding these rpmlint messages: 

0install.src:88: E: hardcoded-library-path in %{_prefix}/lib/0install.net/*.cmxs
0install.src:124: E: hardcoded-library-path in %{_prefix}/lib/0install.net

    Those are architecture-specific files.  Shouldn't they be in %{_libdir}?

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v2.1 or later) (with incorrect FSF address)", "Unknown or
     generated", "*No copyright* Public domain". 179 files have unknown
     license. Detailed output of licensecheck in /home/jamesjer/0install
     /review-0install/licensecheck.txt
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/share/fish/completions
     (zeroinstall-injector, fish), /usr/share/bash-
     completion/completions(zeitgeist, createrepo, why3, bash-completion,
     firewalld, golang, rpmlint, yum, gvfs, glib2, gpaste),
     /var/cache/0install.net/implementations(zeroinstall-injector), /usr/share
     /bash-completion(zeitgeist, createrepo, why3, bash-completion, golang,
     rpmlint, yum, gvfs, glib2, gpaste), /usr/share/fish(zeroinstall-injector,
     fish), /usr/share/zsh(golang, mercurial, zsh, why3, gpaste),
     /var/cache/0install.net(zeroinstall-injector), /usr/share/zsh/site-
     functions(golang, mercurial, zsh, why3, gpaste)

     All of these are normal and expected.

[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[!]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[!]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
[!]: Useful -debuginfo package or justification otherwise.
     Mostly useful, just need to drop the "strip" invocation.
[!]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or desktop-
     file-validate if there is such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: 0install-2.6-1.fc20.x86_64.rpm
          0install-2.6-1.fc20.src.rpm
0install.x86_64: W: spelling-error %description -l en_US decentralised -> decentralized, decentralize, centralized
0install.x86_64: W: spelling-error %description -l en_US centralised -> centralized, centralist, centralism
0install.x86_64: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
0install.x86_64: W: spelling-error %description -l en_US openSUSE -> opens Use, open SUSE, open-SUSE
0install.x86_64: W: spelling-error %description -l en_US sandboxing -> sand boxing, sand-boxing, sandbagging
0install.x86_64: W: spelling-error %description -l en_US virtualisation -> visualization
0install.x86_64: W: non-standard-uid /var/cache/0install.net/implementations zeroinst
0install.x86_64: W: non-standard-gid /var/cache/0install.net/implementations zeroinst
0install.x86_64: W: no-manual-page-for-binary 0alias
0install.src: W: spelling-error %description -l en_US decentralised -> decentralized, decentralize, centralized
0install.src: W: spelling-error %description -l en_US centralised -> centralized, centralist, centralism
0install.src: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
0install.src: W: spelling-error %description -l en_US openSUSE -> opens Use, open SUSE, open-SUSE
0install.src: W: spelling-error %description -l en_US usr -> use, us, user
0install.src: W: spelling-error %description -l en_US sandboxing -> sand boxing, sand-boxing, sandbagging
0install.src: W: spelling-error %description -l en_US virtualisation -> visualization
0install.src:88: E: hardcoded-library-path in %{_prefix}/lib/0install.net/*.cmxs
0install.src:124: E: hardcoded-library-path in %{_prefix}/lib/0install.net
2 packages and 0 specfiles checked; 2 errors, 16 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint 0install
0install.x86_64: W: spelling-error %description -l en_US decentralised -> decentralized, decentralize, centralized
0install.x86_64: W: spelling-error %description -l en_US centralised -> centralized, centralist, centralism
0install.x86_64: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
0install.x86_64: W: spelling-error %description -l en_US openSUSE -> opens Use, open SUSE, open-SUSE
0install.x86_64: W: spelling-error %description -l en_US sandboxing -> sand boxing, sand-boxing, sandbagging
0install.x86_64: W: spelling-error %description -l en_US virtualisation -> visualization
0install.x86_64: W: non-standard-uid /var/cache/0install.net/implementations zeroinst
0install.x86_64: W: non-standard-gid /var/cache/0install.net/implementations zeroinst
0install.x86_64: W: no-manual-page-for-binary 0alias
1 packages and 0 specfiles checked; 0 errors, 9 warnings.
# echo 'rpmlint-done:'



Requires
--------
0install (rpmlib, GLIBC filtered):
    /bin/sh
    hicolor-icon-theme
    libc.so.6()(64bit)
    libcrypto.so.10()(64bit)
    libcrypto.so.10(libcrypto.so.10)(64bit)
    libcurl.so.4()(64bit)
    libdl.so.2()(64bit)
    libev.so.4()(64bit)
    libglib-2.0.so.0()(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libssl.so.10()(64bit)
    libssl.so.10(libssl.so.10)(64bit)
    rtld(GNU_HASH)
    shadow-utils



Provides
--------
0install:
    0install
    0install(x86-64)
    zeroinstall-injector



Source checksums
----------------
http://downloads.sf.net/project/zero-install/0install/2.6/0install-2.6.tar.bz2 :
  CHECKSUM(SHA256) this package     : 1cd06b4b27ce8cc08f2ef334cefa3a6c398cd4355ca426873fb77b25e9d6d1b9
  CHECKSUM(SHA256) upstream package : 1cd06b4b27ce8cc08f2ef334cefa3a6c398cd4355ca426873fb77b25e9d6d1b9


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -n 0install -m fedora-20-x86_64
Buildroot used: fedora-20-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 6 Michel Alexandre Salim 2014-02-14 03:15:37 UTC
(In reply to Jerry James from comment #5)
> Review done on Fedora 20, since the Rawhide buildroot is currently broken
> due to an incomplete icu update.
> 
> Issues, in no particular order:
>  1) Missing BRs on ocaml-biniou-devel and ocaml-easy-format-devel.

Indeed, I must have forgotten to add them, since by submitting review requests for them I obviously know they are required :p Brain fade...

>  2) BR on ocaml-findlib-devel should just be on ocaml-findlib.
>  3) Add "ExclusiveArch: %{ocaml_arches}".  Will this be a problem, since
>     zeroinstall-injector was available for all arches?  That is, non-ocaml
>     arches will not have an upgrade path available to them.
>  4) Remove the "rm -rf $RPM_BUILD_ROOT" at the top of %install.
>  5) Don't strip the cmxs files.
Same as the ocaml- packages

>  6) The latest changelog entry says "Update to 2.6.1", but it appears that
> the
>     package is actually for 2.6, not 2.6.1.
Ouch!

>  7) Speaking of the changelog, I question the usefulness of keeping the
>     changelogs from the previous package.  Think about whether it would be
>     better to start over on the changelog.
Good idea

>  8) The spec file gives the license as "LGPLv2", but README.md contains the
>     "any later version" clause.  Shouldn't the license be "LGPLv2+"?
Good catch. Will peruse the source code files before posting the next revision

>  9) The spec has a BR on ocaml-dbus-devel, but I see this in the build log:
> 
>     obus not found; compiling without D-BUS support
> 
>     I think it wants this: http://forge.ocamlcore.org/projects/obus/.  Does
>     that mean that the BR on ocaml-dbus-devel is unneeded?  Indeed, I see no
>     references in the code to dBus, which is what ocaml-dbus-devel provides.
Ah, something else to package then. Good thing it's optional since ocaml-dbus is the only dbus-related package we carry right now. Will work on that after this, and enable the dependency later on

> 10) "Provides" for the old package name are great, but I don't think that
>     "Obsoletes" is correct.  Doing it this way means that each time you bump
>     NEVR on the new package, it will obsolete the previous version of itself.
>
Yep, forgot to hard-code the last available version there 

> 11) In %description, use the American spelling of centralized, decentralized,
>     and virtualization.
Oh good catch, thanks. The author is British, and having spent some years there myself my radar for British-ism is really off.

> 12) Regarding these rpmlint messages: 
> 
> 0install.src:88: E: hardcoded-library-path in
> %{_prefix}/lib/0install.net/*.cmxs
> 0install.src:124: E: hardcoded-library-path in %{_prefix}/lib/0install.net
> 
>     Those are architecture-specific files.  Shouldn't they be in %{_libdir}?
> 
Indeed.

Comment 7 Michel Alexandre Salim 2014-02-14 04:59:02 UTC
(In reply to Jerry James from comment #5)
> Review done on Fedora 20, since the Rawhide buildroot is currently broken
> due to an incomplete icu update.
> 
> Issues, in no particular order:
>  1) Missing BRs on ocaml-biniou-devel and ocaml-easy-format-devel.
>  2) BR on ocaml-findlib-devel should just be on ocaml-findlib.
>  3) Add "ExclusiveArch: %{ocaml_arches}".  Will this be a problem, since
>     zeroinstall-injector was available for all arches?  That is, non-ocaml
>     arches will not have an upgrade path available to them.

The non-Ocaml-carrying architectures will be stuck on the Python-based 2.3.x, which upstream has stopped working on. Let me ask the development list as to whether they're still maintaining it.

If they are, then I suppose I'll simply not retire the old zeroinstall-injector...

Spec URL: http://salimma.fedorapeople.org/specs/ocaml/0install.spec
SRPM URL: http://salimma.fedorapeople.org/specs/ocaml/0install-2.6.1-1.fc20.src.rpm

Comment 8 Jerry James 2014-02-14 16:46:13 UTC
I just tried to build the latest version in mock for fedora-rawhide-x86_64, and the build failed:

File "_none_", line 1:
Error: Files /usr/lib64/ocaml/oUnit/oUnit.cmxa
       and /usr/lib64/ocaml/stdlib.cmxa
       make inconsistent assumptions over implementation Arg
Command exited with code 2.
make[2]: *** [ocaml] Error 10

which I have filed as bug 1065447.  I will try building against Fedora 20 instead, but you will be unable to build this package in Rawhide until that bug is resolved.

Comment 9 Michel Alexandre Salim 2014-02-14 16:54:11 UTC
Worrying when it's the unit test library that fails :p -- Cc:ing myself on that bug, thanks.

Building against F20 should work fine, I'm using a mock build on my machine right now.

Comment 10 Jerry James 2014-02-14 17:14:02 UTC
This one was missed:

4) Remove the "rm -rf $RPM_BUILD_ROOT" at the top of %install.

After doing this one:

5) Don't strip the cmxs files.

we now get this output from rpmlint:

0install.x86_64: W: unstripped-binary-or-object /usr/lib64/0install.net/gui_gtk.cmxs

which happens because the debuginfo handlers look for files with execute permission, and this file is 0644.  Change it to 0755, and everything should work correctly.

Comment 11 Michel Alexandre Salim 2014-02-15 04:22:59 UTC
Aha, of course. Fixed now, thanks


Spec URL: http://salimma.fedorapeople.org/specs/ocaml/0install.spec
SRPM URL: http://salimma.fedorapeople.org/specs/ocaml/0install-2.6.1-2.fc20.src.rpm

Comment 12 Jerry James 2014-02-15 18:49:02 UTC
That fixes it.  And Richard's fix for bug 1065447 worked; this package now builds in Rawhide, too.  This package is APPROVED.

Comment 13 Michel Alexandre Salim 2014-02-16 03:08:52 UTC
Many thanks for the reviews!

New Package SCM Request
=======================
Package Name: 0install
Short Description: A decentralized cross-distribution software installation system
Owners: salimma
Branches: f19 f20
InitialCC:

Comment 14 Gwyn Ciesla 2014-02-17 13:08:39 UTC
Git done (by process-git-requests).

Comment 15 Fedora Update System 2014-02-17 19:36:22 UTC
0install-2.6.1-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/0install-2.6.1-2.fc20

Comment 16 Fedora Update System 2014-02-18 13:34:53 UTC
0install-2.6.1-2.fc20 has been pushed to the Fedora 20 testing repository.

Comment 17 Fedora Update System 2014-02-19 02:49:25 UTC
0install-2.6.1-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/0install-2.6.1-2.fc19

Comment 18 Fedora Update System 2014-02-26 13:56:11 UTC
0install-2.6.1-2.fc20 has been pushed to the Fedora 20 stable repository.

Comment 19 Fedora Update System 2014-03-05 05:12:33 UTC
0install-2.6.1-2.fc19 has been pushed to the Fedora 19 stable repository.


Note You need to log in before you can comment on or make changes to this bug.